# File:           $RCSfile: apt.spec,v $
# Revision:       $Revision: 1.11 $
# Last change:    $Date: 2004/08/20 10:05:50 $

Name: apt
Version: 0.5.15cnc6
Release: rb5
Summary: Advanced Packaging Tool
Group: System/Packages
License: GPL
Packager: Richard Bos <rbos@users.sourceforge.net>
Url: http://moin.conectiva.com.br/AptRpm
Source0: http://moin.conectiva.com.br/files/AptRpm/attachments/%{name}-%{version}.tar.bz2
Source1:  apt.conf
Source2:  rpmpriorities-%{suse_version}
Source4:  sources.list-%{suse_version}_%{_arch}
Source5:  security.list-%{suse_version}_%{_arch}
#Source10: laiskiainen_org_apt.tar.bz2
Source12: apt-wrap.tar.bz2
Source13: README.lua
Patch2:   apt.nocow.patch
Patch3:   apt-mdcache.patch

%if "%{_vendor}" == "suse"
Requires: rpm >= 4.1 bzip2
BuildRequires: rpm rpm-devel popt-devel make autoconf
BuildRequires: bzip2, gettext, 
BuildRequires: db, db-devel, libstdc++, gcc-c++
BuildRequires: glibc-devel, gcc
BuildRequires: ncurses-devel readline-devel
BuildRequires: docbook-xsl-stylesheets >= 1.61.3
%else
Requires: rpm >= 4.0.0, bzip2-libs
BuildRequires: rpm-devel >= 4.0.0, bzip2-devel
BuildRequires: docbook-utils
%endif
BuildRequires: xmlto 
BuildRequires: libstdc++-devel, zlib-devel, help2man
BuildRoot: %{_tmppath}/making_of_%{name}-%{version}

%description
A port of Debian's apt tools for RPM based distributions.  It provides the
apt-get utility that provides a safe and simple way to install and upgrade
packages.  APT features complete installation ordering, multiple source
capability and several other unique features.

%package devel
Summary: Development files and documentation for APT's libapt-pkg.
Group: System/Libraries
PreReq: %{name} = %{version}-%{release}

%description devel
This package contains the header files and static libraries for developing
with APT's manipulation library, modified for RPM.

%package libs
Summary: libraries for APT for rpm
Group: System/Libraries

%description libs
This package contains libraries needed by apt and some other packages

%package server
Summary: Tools to create an apt repository.
Group: System/Libraries

%description server
This package provides the tools to create an apt repository, modified for RPM.

%prep
%setup -q -n %{name}-%{version}
%patch2 -p1
%patch3 

# -D -a10:
# -D  do not delete top directory
# -a10 setup for Source10 after changing to top directory
# %setup -D -T -a 10
%setup -D -T -a 12

%build
%if "%{_arch}" == "x86_64"
export LDFLAGS=$LDFLAGS"-L/usr/lib64"
CXXFLAGS="-I/usr/include/g++/x86_64-suse-linux"
%else
CXXFLAGS="-I/usr/include/g++/i586-suse-linux"
%endif

%configure --enable-docdir=%{_defaultdocdir} --disable-docs
make

# workaround to get the xml manpages processed, until they are
# officially incorperated into apt-rpm
cd doc
for MAN in apt-cache.8.xml apt-cdrom.8.xml apt.conf.5.xml apt-config.8.xml apt-get.8.xml apt_preferences.5.xml sources.list.5.xml vendors.list.5.xml apt.1.xml; do
	xmlto man $MAN
done
cd ..

# Organize the example lua scripts into 1 directory that will be stored
# in %{_docdir}
mkdir lua-scripts
cp -R contrib/* lua-scripts
cp %{SOURCE13} lua-scripts
# Remove the lua scripts that are going to be installed
for DIR in apt-groupinstall apt-wrapper list-extras list-nodeps; do
	rm -rf lua-scripts/$DIR
done

%install
%makeinstall

# The config files and empty dirs
install -d -m 755 %{buildroot}%{_sysconfdir}/apt/{apt.conf.d,sources.list.d}
install -d -m 755 %{buildroot}%{_libdir}/apt/scripts
cp -a %{SOURCE1} %{buildroot}%{_sysconfdir}/apt/apt.conf.d
cp -a %{SOURCE2} %{buildroot}%{_sysconfdir}/apt/rpmpriorities
cp -a %{SOURCE4} %{buildroot}%{_sysconfdir}/apt/sources.list
cp -a %{SOURCE5} %{buildroot}%{_sysconfdir}/apt/security.list

# Mode 644 seems sufficient for lua scripts
install -m 644 contrib/list-extras/list-extras.lua  %{buildroot}%{_libdir}/apt/scripts
install -m 644 contrib/list-extras/list-extras.conf %{buildroot}%{_sysconfdir}/apt/apt.conf.d
install -m 644 contrib/list-nodeps/list-nodeps.lua  %{buildroot}%{_libdir}/apt/scripts
install -m 644 contrib/list-nodeps/list-nodeps.conf %{buildroot}%{_sysconfdir}/apt/apt.conf.d
install -m 644 my-lua-scripts/*.lua  %{buildroot}%{_libdir}/apt/scripts
install -m 644 my-lua-conf/*.conf %{buildroot}%{_sysconfdir}/apt/apt.conf.d
install -m 755 my-lua-scripts/groupinstall-backend-suse %{buildroot}%{_libdir}/apt/scripts

install -d -m 755 %{buildroot}%{_mandir}/man1
install -d -m 755 %{buildroot}%{_mandir}/man5
install -d -m 755 %{buildroot}%{_mandir}/man8
install -m 644 doc/*1 %{buildroot}%{_mandir}/man1
install -m 644 doc/*5 %{buildroot}%{_mandir}/man5
install -m 644 doc/*8 %{buildroot}%{_mandir}/man8

install -m 755 cmdline/apt %{buildroot}%{_bindir}/

# cache and state directories
mkdir -p %{buildroot}%{_localstatedir}/cache/apt/archives/partial
mkdir -p %{buildroot}%{_localstatedir}/state/apt/lists/partial

%post
if [ -s /etc/apt/apt.conf ]; then

	# /etc/apt/apt.conf.d/apt.conf is delivered with the apt rpm
	# just assume it exists...
	if diff -q /etc/apt/apt.conf /etc/apt/apt.conf.d/apt.conf; then

		# They are the same.  It is save to remove /etc/apt/apt.conf
		rm /etc/apt/apt.conf
		echo "/etc/apt/apt.conf has been moved to /etc/apt/apt.conf.d/apt.conf"
	else
		# They differ
		echo "Note: it is adviced to move the configuration file:"
		echo " /etc/apt/apt.conf to /etc/apt/apt.conf.d/apt.conf"
        fi
fi

FILE=/etc/apt/apt.conf.d/gpg-checker.conf
if [ -s $FILE ]; then

	if grep -q RPM::GPG-Check $FILE; then
		sed s,RPM::GPG-Check,GPG::Check, $FILE > /tmp/gpg-checker.$$
		mv /tmp/gpg-checker.$$ $FILE
	fi
fi

%post libs
%run_ldconfig

%postun libs
%run_ldconfig

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)
%doc AUTHORS* COPYING* TODO doc/examples/ lua-scripts
%dir %{_sysconfdir}/apt
%config %{_sysconfdir}/apt/rpmpriorities
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/apt.conf 
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/list-extras.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/list-nodeps.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/pkglog.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/post.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/gpg-import.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/gpg-checker.conf
%config(noreplace) %{_sysconfdir}/apt/apt.conf.d/apt-groupinstall.conf
%config(noreplace) %{_sysconfdir}/apt/sources.list
%config(noreplace) %{_sysconfdir}/apt/security.list
# %config(noreplace) %{_sysconfdir}/apt/vendors.list
%dir %{_sysconfdir}/apt/apt.conf.d
%dir %{_sysconfdir}/apt/sources.list.d
%{_bindir}/apt*
%{_libdir}/apt
%{_mandir}/man?/*
%{_datadir}/locale/*/LC_MESSAGES/apt.mo
%{_localstatedir}/cache/apt
%{_localstatedir}/state/apt

%files devel
%defattr(-, root, root)
%{_includedir}/apt-pkg
%{_libdir}/*.a
# %exclude %{_libdir}/*.la
%{_libdir}/*.so

%files libs
%defattr(-, root, root)
%{_libdir}/*.so.*
%{_libdir}/*.la

%files server
%defattr(-, root, root)
%{_bindir}/gen*

%changelog
* Fri Aug 20 2004 Richard Bos <rbos@users.sourceforge.net>
- Used versioned files for rpmpriorities, sources.list and security.list
- Do not include Panu's lua scripts in the doc directory anylonger, but refer
  to his webpage instead.  Many of his scripts are just installed.
- Be more selective in which lua scripts from the contrib dir are included
  in the doc directory
- updated groupinstall-backend-suse and gpg-import.lua scripts

* Tue Aug 17 2004 Richard Bos <rbos@users.sourceforge.net>
- Changed RPM::GPG-Check to GPG:Check in /etc/apt/apt.conf.d/gpg-checker.conf
- Remove lua dependency, apt has it embedded
- Updated gpg-import.lua to automatically import gpg public keys
  delivered with an rpm
- Updated groupinstall to support synaptic
- Man pages synched with upstream apt
- Add cache support for apt repository creation

* Thu Jun 24 2004 Richard Bos <rbos@users.sourceforge.net>
- Change showgroups to groupnames to be in sync with Fedora

* Mon Jun 21 2004 Richard Bos <rbos@users.sourceforge.net>
- Added group options

* Wed Mar 24 2004 Richard Bos <rbos@users.sourceforge.net>
- Upgraded to 0.5.15cnc6
- Removed --test and reinstall patches.  They are now integrated.
- Add list-nodeps

* Mon Mar 15 2004 Richard Bos <rbos@users.sourceforge.net>
- Release a update gpg-checker script to prevent rpm locks

* Fri Feb 27 2004 Richard Bos <rbos@users.sourceforge.net>
- Added gpg-checker

* Mon Feb 23 2004 Richard Bos <rbos@users.sourceforge.net>
- Update from 0.5.5 to 0.15.5
- Moved apt.conf from /etc/apt/ to /etc/apt/apt.conf.d/
- Added actions: redepends, xsvg, reinstall, list-extras
  The latter action (list-extras) is obtained using a lua plugin script
- Updated manual pages
- Added option: --hold, --postscript/--no-postscript
- Package changes are being logged in /var/log/apt.log, using a lua plugin
  script
- After a pkg change (removal/install/upgrade/degrade) SuSEconfig and ldconfig
  are now automatically run, using a lua plugin script.

* Wed Oct 16 2003 Richard Bos <rbos@users.sourceforge.net>
- Build for suse-9.0
- Changed the sources.list file
- Updated the dependencies
- Make better use of suse rpm macros
- Directory scripts moved from /etc/apt to /usr/lib/apt
- Removed the apt wrapper script apt-rpm and added the wrapper apt
- Added lua example scripts
- Prevent gpg-pubkey warning by apt

* Tue Jun 11 2003 Richard Bos <rbos@users.sourceforge.net>
- Updated to apt version 0.5.5cnc6
- Moved the sources.list file from /etc/apt/sources.list.d to /etc/apt
- apt-rpm is now taken from the contribs directory

* Tue May 13 2003 Richard Bos <rbos@users.sourceforge.net>
- Added libstdc++-devel as build dependency
- made a common BuildRequires

* Sun May 04 2003 Richard Bos <rbos@users.sourceforge.net>
- Added apt-rpm a wrapper around apt-get to easily pass rpm arguments to rpm
- Move sources.list to sources.list.d directory

* Fri Apr 25 2003 Richard Bos <rbos@users.sourceforge.net>
- Corrected dependencies

* Thu Apr 24 2003 Richard Bos <rbos@users.sourceforge.net>
- Added language files
- Created an extra package apt-libs

* Wed Apr 23 2003 Richard Bos <rbos@users.sourceforge.net>
- Removed the text "All your base are belong to us!!!" from genbasedir
- Removed the text "This APT has Super Cow Powers." from apt-get and apt-shell

* Mon Apr 14 2003 Richard Bos <rbos@users.sourceforge.net>
- Update to latest snapshot, first suse-8.1 build.
- On advice of Eberhard Moenkeberg a seperate server rpm is provided.

